@echo off
if (%cnt%)==() goto Syntax
:: ** add an underscore to the start of the original input string
set c=_%cnt%
for %%x in (# f inc) do set %%x=
:: ** entry point to reverse (mirror) the string in %c%
::    EG if %c%=100CBA_ then %b%?? becomes _ABC001
:Mirror       ================================================================
set d=%c%
set a=%d%
:: ** strip off the first character from %c%
::    EG if %c%=ABC000 then %c% becomes BC000
for %%x in (/%c%) do set c=%%x
:: ** find out what the first character was and store it in %a%
for %%x in (/%d%) do if (%%x%c%)==(%d%) set a=%%x
:: ** assemble the string in reverse order
set b=%a%%b%
if not (%d%)==(%c%) goto Mirror
:: ** string in %c% now reversed and saved in %b%
:: set c=
:: ** If %#% is set to anything the addition is finished, and end
if not (%#%)==() goto End
:: ** entry point to strip the leftmost character from %b% and
::    save it in %n%
:GetLeftChar  ================================================================
set d=%b%
for %%x in (/%b%) do set c=%%x
for %%x in (/%d%) do if (%%x%c%)==(%d%) set n=%%x
:: ** initialise variables for the Compare routine
for %%x in (# d) do set %%x=
set p=901234567890
:Compare      ================================================================
set d=%p%
:: ** strip the leftmost number from %p% and save it in %#%
::    (%p% loses the leftmost number and it is saved in %x% for comparing)
for %%x in (/%d%) do set p=%%x
for %%x in (/%d%) do if (%%x%p%)==(%d%) set #=%%x
:: ** if there is a match, set %n%=! so that the next time through the
::    loop the correct addition character will be added, in AddToStr
if (%n%)==(!) goto AddToStr
if (%#%)==(%n%) set n=!
:: ** test for a TRAILING non numeric character
::    If there is no match then %d% becomes equal to 0 and the character
::    in %n% is non numeric
if not (%d%)==(0) goto Compare
:: ** if the final result string %f% is equal to nothing and the trailing
::    character was not a numeric one, go to print the error message
if (%f%)==() goto Error
:: ** To get to here, the current character is a non numeric one
::    Prepend a dummy character to the string in %b% to be stripped
::    in the AddToStr routine below
set b=_%b%
:: ** if %g%=1 then the prior character was 9 and there is a carry.
::    Set %#% equal to 1 so that the extra character can be added onto the
::    answer
if (%g%)==(1) set #=1
:: ** entry point to perform the addition by appending the character in %#%
::    (from %p%) onto the answer.
:AddToStr     ================================================================
:: ** add the matched number to the end of %f%
set f=%f%%#%
:: ** strip the character just tested from the left hand side of the remaining
::    string in %b%
for %%x in (/%b%) do set e=%%x
:: ** if %#% is a character other than 0 then the addition is completed.
::    Append the remaining string and go to Mirror
if not (%#%)==(0) set b=
if not (%#%)==(0) set c=%f%%e%
if not (%#%)==(0) goto Mirror
:: ** %x%=0 so there is a carry of 1.  If  %e%=_  then the input string has
::    runout and all there is left to do is to add the carry and the remaining
::    string to the end of %c% (remembering that after Mirror %c% will be
::    reversed)
if (%e%)==(_) set b=
if (%e%)==(_) set c=%f%1%e%
if (%e%)==(_) goto Mirror
:: ** Make %b% equal to the next character (and the rest of the string) to
::    be compared
set b=%e%
:: ** Set the flag %g% that shows there is a carry
set g=1
goto GetLeftChar
:Error2       ================================================================
echo [%0] ERROR both parm 1 and INC are set
goto Abort
:Error        ================================================================
echo [%0] Invalid character `%n%' in %1
echo .
:Syntax       ================================================================
echo.
echo You must place a number in the environment string CNT
echo (e.g. SET CNT=FILE12)
echo (Digits can be preceded by alpha characters)
echo.
goto Abort
:End          ================================================================
:: ** remove leading underline
for %%x in (/%b%) do set cnt=%%x
:Abort        ================================================================
:: ** Reset all environment variables that were used
for %%x in (# a b c d e f g n p) do set %%x=
